PROGRAM_NAME='BSS_Soundweb_London'

//THIS PROGRAM WAS WRITTEN AND TESTED BY THE MANUFACTURER
//THIS MODULE IS DESIGNED TO CONTROL ALL BSS AUDIO SOUNDWEB LONDON HARDWARE
//VIA RS232 OR TCP/IP
//BLU-16
//BLU-32
//BLU-80
//BLU-120
//BLU-160
//BLU-320
//BLU-800

		    //ADDED ROOM_COMBINE FUNCTIONALITY
		    //ADDED BUG FIXES (T=0 IN DATA:ONLINE, I=T IN PROCESS_FEEDBACK, 'GET_EVENT' IN SET FUNCTIONS)
		    //IMPROVED DATA RECEIVING EVENTS TO HANDLE THE DATA:ONLINE SUBSCRIBE TRAFFIC LOAD
		    //UPDATED HELP FILE
				
				
//PLEASE READ THE MODULE HELP DOCUMENT LOCATED IN THE DIRECTORY!!!  THIS FILE IS ALSO MAPPED IN THE NETLINX STUDIO "OTHER" TREE

//INFOCOMM_2006 FILE SHOWS EXAMPLE OF CONTROL ON ALL PROCESSING OBJECTS


//SE 4/15/08

(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

#IF_NOT_DEFINED dvSOUNDWEB
dvSOUNDWEB=5001:1:0 //real device RS232 port 1
#END_IF

#IF_NOT_DEFINED dvTP
dvTP = 10001:1:0
#END_IF
//dvWeb = 225:1:0 //web panel


(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

//MUST ASSIGN [NODE <2 BYTES>, VD <1 BYTE>, OBJECT ID <3BYTES>] (ALWAYS 6 BYTES) FOR EVERY DEVICE!!!!
//GET THIS BY COPY AND PASTING FROM PROPERTIES WINDOW IN BSS AUDIO LONDON ARCHITECT (SEE HELP FILE FOR MORE INFO)
// DO NOT TAKE THIS ADDRESS FROM THE DI-TOOL BAR!! TAKE IT FROM THE PROPERTIES WINDOW OF THE PROCESSING OBJECT

CHAR IO_CARD1[] = {$11,$8B,$03,$00,$00,$01};// I/O CARD SLOT A IS ALWAYS OBJECT ID $00,$00,$01
CHAR IO_CARD2[] = {$11,$8B,$03,$00,$00,$02};// I/O CARD SLOT B IS ALWAYS OBJECT ID $00,$00,$02
CHAR IO_CARD3[] = {$11,$8B,$03,$00,$00,$03};// I/O CARD SLOT C IS ALWAYS OBJECT ID $00,$00,$03
CHAR IO_CARD4[] = {$11,$8B,$03,$00,$00,$04};// I/O CARD SLOT D IS ALWAYS OBJECT ID $00,$00,$04

//This file only shows a couple of example processing objects. 
//The main emphasis is on the Room Combine processing object
//See Infocomm_06 included in this demo for example code for nearly all available processing objects
//See the help file for additional examples
CHAR HALL_A[] =       {$11,$8B,$03,$00,$01,$00};//ROOM_COMBINE PROCESSING OBJECT
CHAR CHAP_AUTO[] =    {$11,$8B,$03,$00,$01,$01}; //AUTOMIXER DEVICE IN LONDON ARCHITECTURE
CHAR CC_AUTO[] =      {$11,$8B,$03,$00,$01,$02}; //AUTOMIXER 
CHAR VIDEO_SERVER[] = {$11,$8B,$03,$00,$01,$03};//MATRIX MIXER
CHAR BLU_ROOMGAIN[] = {$11,$8B,$03,$00,$01,$04}; //GAIN OBJECT
CHAR RED_ROOMGAIN[] = {$11,$8B,$03,$00,$01,$05}; //N-GAIN OBJECT



(**************** STRING FORMATING CONSTANTS ******************************************** *)
STX = $02; ETX = $03;
ACK = $06; NAK = $15;
ESC = $1B; //ESCAPE CHAR
ET = $88; //EVENT
(******************************************************************************************)

(*******************  DEVICE AND PARAMETER CONSTANTS - MUST KEEP ***************************************************)
(*******************************************************************************************************************)
//THESE CONSTANTS ARE USED FOR 'FRIENDLY' PARAMETER FUNCTION CALLS. 
//SEE EXAMPLE PROGRAM BELOW FOR USE.  SEE HELP FILE FOR ADDITIONAL EXAMPLES
 
(*  DEVICE CONSTANTS FOR <DEVICE> FUNCTION PARAMETER *)
AUTOMIXER = 1; MIXER = 2;MM = 4; ROUTER =6; METER = 7; SOURCE_SELECTOR = 8; SOURCE_MATRIX = 9;
N_GAIN = 10; INPUT_CARD = 11; OUTPUT_CARD = 12; ROOM_COMBINE = 26;

(* PARAMETER CONSTANTS <PARAM> FUNCTION PARAMETER  *)
UNMUTE = 0; MUTE = 1; ROUTE = 1; GAIN = 3;UNROUTE = 0;  
POLARITY_ON = 1; POLARITY_OFF = 0;

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_MIXER' <PARAM> FUNCTION PARAMETER  *)
SOLO= 13;GROUP = 14;AUX = 15; OVERRIDE = 16; AUTO = 17; AUX_GAIN = 18; 
PAN = 19; OFF_GAIN = 20;GROUP_GAIN = 21; 

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_ROOMCOMBINE' <PARAM> FUNCTION PARAMETER  *)
SOURCE_MUTE = 30; BGM_MUTE = 31; MASTER_MUTE = 32; SOURCE_GAIN = 33; BGM_GAIN = 34; MASTER_GAIN = 35, BGM_SELECT = 36; 
PARTITION = 37;

(* PARAMETER CONSTANTS SPECIFICALLY FOR 'SET_PRESET' <PARAM> FUNCTION PARAMETER  *)
DEVICE_PRESET = 1; PARAMETER_PRESET = 2; 

(* PARAMETER CONSTANTS ONLY WHEN <DEVICE> == INPUT_CARD || OUTPUT_CARD *)
//GAIN IS ALSO VALID BUT ALREADY DEFINED ABOVE
PHANTOM = 22; REFERENCE = 23; ATTACK = 24; RELEASED = 25;

(* GENERAL FORMAT CONSTANTS *)
A=1;B=2;C=3;D=4; //INPUT_CARD DENOTIONS 
L = 1; R = 3;//LEFT CHANNEL, RIGHT CHANNEL FOR MIXERS/AUTOMIXERS
(*******************************************************************************************************************)
(*******************************************************************************************************************)



INTEGER GAIN_STEP_PER = 1; //GAIN STEP IF USING SET_GAIN_PERCENT
INTEGER MAX_RAMPGAIN_PER = 100; //THESE ARE VALUES USING SUBSCRIBE%
INTEGER MIN_RAMPGAIN_PER = 0;

INTEGER TL1 =1;//TIMELINE FOR FEEDBACK


(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE INTEGER bDEBUG_FLAG 
VOLATILE CHAR cBUFFER[1000] //COMM PORT BUFFER
VOLATILE INTEGER nAttempts= 0     // counts the number of times we iterate before we should have received a full message
VOLATILE INTEGER STARTUP; //FLAG USED IN DEFINE_START ROUTINE
VOLATILE INTEGER T; //NUMBER OF TIMES 'SUBSCRIBE' OR 'SUBSCRIBE %' CALLED FROM DATA_EVENT:ONLINE.  USED FOR FB[] <FEEDBACK> ARRAY POPULATING IN SUBSCRIBE AND SUBSCRIBE% FOR TRUE FEEDBACK PURPOSES
VOLATILE INTEGER iGAIN_FRACTION; //USED IN PROCESS FEEDBACK FOR ROUNDING PURPOSES ON SET_GAIN%

//SEE HELP FILE FOR COMPLETE DESCRIPTION OF FB[][]
CHAR FB[200][12]; //FEEDBACK ARRAY - MUST MANUALLY ASSIGN DIMENSION OF ROWS[1] IF OVER 200 VARIABLES ARE USED FOR TRUE FEEDBACK (ie MAKE LARGER IF NEEDED); COLUMN[2] MUST ALWAYS BE 12!!


LONG REPEAT_TIME[1];//TIMELINE
VOLATILE INTEGER iRM1_GROUP, iRM2_GROUP, iRM3_GROUP, iRM4_GROUP;//VARS TO PREVENT OVER-SENDING OF DYNAMIC TP COMMANDS IN THE FEEDBACK ROUTINE
INTEGER bUPDATE_OK[13];//BUTTON EVENTS ON TP_BARGRAPHS TO PREVENT FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS

(* SAMPLE MATRIX ROUTING USED IN BUTTON_EVENT*)
INTEGER MATRIX_INPUT;
INTEGER MATRIX_OUTPUT;

(* SAMPLE PROGRAMMING CONTROLLING AUTOMIXER GAINS *)
INTEGER BUTTON2[10]; //PSEUDO FEEDBACK EXAMPLE FOR THOSE WHO DON'T CARE ABOUT TRUE FEEDBACK (OR DON'T WANT TO DEAL WITH IT)
INTEGER RAMP_GAIN_PER; //RAMP_GAIN IN PERCENT <0-100>
INTEGER MASTEROUT_VOL; //KEEP TRACK OF MASTEROUT VOLUME

INTEGER BARGRAPH; //LINKS BARGRAPH VALUE IN LEVEL_EVENT TO INC/DEC IN BUTTON_EVENT

(* SAMPLE USED IN DEFINE_PROGRAM FOR UPDATING VOLUME BAR GRAPHS *)
INTEGER VOLUME;
LONG intVOL;
INTEGER MYVOL;

(*SUBSCRIBING TO A METER USING SUBSCRIBE%. UPDATING TO BARGRAPH IN DEFINE_PROGRAM *)
CHAR METER_FB[4];
LONG intMETER_FB;
INTEGER myMETER;
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)
DEFINE_CALL 'SET_VAL'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM,INTEGER VALUE)
{ 
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF S_V
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF S_V
    LOCAL_VAR CHAR MY_DATA[4]; //FOUR BYTE DATA FIELD THAT HOLDS THE VALUE OF THE S_V
    LOCAL_VAR CHAR MY_STRING[13];//COMPLETE MESSAGE BEFORE BEING PADDED WITH STX,CHECKSUM,ETX, AND SPECIAL CHAR SUBSITUTION
    LOCAL_VAR CHAR EVENT; //DETERMINES DATA TYPE FOR S_V
    LOCAL_VAR CHAR GET_EVENT;//DETERMINES DATA TYPE FOR GET S_V
    
    IF(DEVICE = OUTPUT_CARD || DEVICE = INPUT_CARD)
    {
	EVENT = $8D;  // FOR SENDING PERCENT VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0"; //when using percent only 2nd Data byte is utilized for range 0-100
    }
    ELSE
    {
	EVENT = $88; //FOR SENDING DISCRETE VALUES
	GET_EVENT = $89; //FOR GETTING DISCRETE VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE"; //when using discrete the only value is 0 or 1 (on/off)
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    MY_STRING = "GET_EVENT,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    CALL 'CHECKSUM'(MY_STRING) //GET_FUNCTION FOR FEEDBACK
}

DEFINE_CALL 'SET_MIXER'(CHAR OBJECT[6], INTEGER INPUT, INTEGER OUTPUT, INTEGER PARAM, INTEGER VALUE)
//                  OBJECT = NODE+VD+OBJECT;PARAM = MUTE, SOLO, AUX, GROUP,OVERRIDE,AUTO,AUX ;VALUE = MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
{
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF DATA
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF DATA
    LOCAL_VAR INTEGER DEVICE;//SPECIFIES TYPE OF DEVICE BEING PASSED TO 'GET_SV' 
    LOCAL_VAR CHAR MY_DATA[4]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR MY_STRING[13];
    LOCAL_VAR CHAR EVENT; 
    LOCAL_VAR CHAR GET_EVENT;//DETERMINES DATA TYPE FOR GET S_V

    DEVICE = MIXER;
    IF(PARAM = PAN || PARAM = OFF_GAIN || PARAM = AUX_GAIN || PARAM = GROUP_GAIN)
    {
	EVENT = $8D; //FOR SENDING PERCENT VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0";
    }
    ELSE
    {
	EVENT = $88; //FOR DISCRETE VALUES
	GET_EVENT = $8E;//FOR GETTING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE";
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //GET_FUNCTION FOR FEEDBACK
    MY_STRING = "GET_EVENT,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    CALL 'CHECKSUM'(MY_STRING)
}

DEFINE_CALL 'SET_ROOMCOMBINE'(CHAR OBJECT[6], INTEGER INPUT, INTEGER OUTPUT, INTEGER PARAM, INTEGER VALUE)
//           OBJECT = NODE+VD+OBJECT;PARAM = SOURCE_GAIN,BGM_GAIN, MASTER_GAIN, SOURCE_MUTE, BGM_MUTE, MASTER_MUTE,BGM_SELECT, ;VALUE = MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0> FOR DISCRETES; 0-100 <PERCENT> FOR GAINS; 0-# OF BGM INPUTS FOR BGM_SELECT
{
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;//LOW BYTE OF DATA
    LOCAL_VAR INTEGER S_VHIGH;//HIGH BYTE OF DATA
    LOCAL_VAR INTEGER DEVICE;
    LOCAL_VAR CHAR MY_DATA[4]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR MY_STRING[13];
    LOCAL_VAR CHAR EVENT; 

    DEVICE = ROOM_COMBINE;
    IF(PARAM = SOURCE_GAIN || PARAM = BGM_GAIN || PARAM = MASTER_GAIN )
    {
	EVENT = $8D; //FOR SENDING PERCENT VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "0,VALUE,0,0";
    }
    ELSE
    {
	EVENT = $88; //FOR DISCRETE VALUES
	S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
	S_VLOW =  LO_BYTE(S_V);//LOW BYTE
	S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
	MY_DATA = "$00,$00,$00,VALUE";
    }
    
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
    
    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //GET_FUNCTION FOR FEEDBACK
    IF (EVENT = $88) //DISCRETE
	MY_STRING = "$89,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";
    ELSE //PERCENT
	MY_STRING = "$8E,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00";

    CALL 'CHECKSUM'(MY_STRING)	    

}

DEFINE_CALL 'SET_GAIN'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT, SLONG VALUE)
{                  //  OBJECT = NODE+VD+OBJECT; DEVICE = MM <MANUAL MIXER>,AUTOMIXER, MIXER, GAIN<ENTER 0 IN INPUT AND OUTPUT FIELD TO SPECIFY SINGLE CHANNEL GAIN DEVICE>, N_GAIN :VALUE = -300,000 <-> 100,000
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW; //LOW BYTE OF DATA 
    LOCAL_VAR INTEGER S_VHIGH; //HIGH BYTE OF DATA
    LOCAL_VAR CHAR MY_DATA[4]; //DATA VALUE
    LOCAL_VAR INTEGER GAIN_A[4]; //CREATE ARRAY TO RETURN LONG GAIN BYTES BY_REF
    LOCAL_VAR CHAR MY_STRING[13]; 
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR INTEGER PARAM;
    
    EVENT = $88;
    PARAM = GAIN;
    
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    CALL 'SLONG_BYTES'(VALUE,GAIN_A)
    MY_DATA = "GAIN_A[1],GAIN_A[2],GAIN_A[3],GAIN_A[4]"; //MUST CONVERT INTO RECEIVING TYPE
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)
}

DEFINE_CALL 'SET_GAIN%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT, INTEGER PERCENT) //1% = 1/3dB
{                  //  OBJECT = NODE+VD+OBJECT, DEVICE = MM <MANUAL MIXER>,AUTOMIXER, MIXER, GAIN<ENTER 0 IN INPUT AND OUTPUT FIELD TO SPECIFY SINGLE CHANNEL GAIN DEVICE>, N_GAIN :PERCENT = 0.0 - 100.0
    LOCAL_VAR INTEGER S_V;//STATE VAR
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR MY_DATA[4]; //DATA VALUE
    LOCAL_VAR INTEGER GAIN_A[4]; //CREATE ARRAY TO RETURN LONG GAIN BYTES BY_REF
    LOCAL_VAR CHAR MY_STRING[13]; 
    LOCAL_VAR LONG MY_PERCENT;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR INTEGER PARAM;
    
    EVENT = $8D; //Set_Percent
    PARAM = GAIN;
    
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    MY_DATA = "0,PERCENT,0,0"
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    CALL 'CHECKSUM'(MY_STRING)

    //THESE STATEMENTS ARE ESSENTIALLY A 'GET' STATEMENT.  AFTER SENDING STRING GET_VALUE.
    //UNCOMENT NEXT TWO LINES IF THE PROGRAMMER WISHES TO RECEIVE A RESPONSE TO EVERY GAIN STRING SENT.
    //MY_STRING = "$8E,OBJECT,S_VHIGH,S_VLOW,$00,$00,$00,$00"; //$8E Get_Percent
    //CALL 'CHECKSUM'(MY_STRING) //GET_FUNCTION FOR FEEDBACK

}


DEFINE_CALL 'SET_PRESET'(INTEGER PRESET_TYPE,INTEGER PRESET_NUMBER)
{
LOCAL_VAR CHAR SEND[10];
LOCAL_VAR CHAR EVENT;
    
    IF(PRESET_TYPE = PARAMETER_PRESET)
	EVENT = $8C;
    ELSE IF (PRESET_TYPE = DEVICE_PRESET)
	EVENT = $8B;
    ELSE //ERROR MESSAGE TO CONSOLE
	SEND_COMMAND 0,"'BSS_ERROR: Set_Preset - PARAM TYPE NOT FOUND.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
    
    SEND = "EVENT,$0,$0,$0,PRESET_NUMBER";
    CALL 'CHECKSUM'(SEND)

}
DEFINE_CALL 'SUBSCRIBE'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_DATA[4];
    LOCAL_VAR CHAR MY_STRING[13];

    
    EVENT = $89; //EVENT FOR SUBSCRIBE REGULAR
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM = METER)
	PARAM =100;//METER SUBSCRIPTION RATE
    ELSE
	PARAM = 0;//ALL OTHER TYPES MUST HAVE DATA = 0 WHEN SUBSCRIBING
	
    MY_DATA = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms <ONLY FOR METERS>
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    
    IF (STARTUP) //IF CALLED FROM STARTUP EVENT.  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.  
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_DATA";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE
}

DEFINE_CALL 'SUBSCRIBE%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];
    
    EVENT = $8E; //EVENT FOR SUBSCRIBE PERCENT
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM == METER)
	PARAM =100;
    ELSE
	PARAM = 0;
	
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    
    IF (STARTUP) //IF CALLED FROM STARTUP EVENT.  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE
}

DEFINE_CALL 'UN_SUBSCRIBE'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];
    
    EVENT = $8A; //EVENT FOR UN_SUBSCRIBE REGULAR
	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    
    IF (PARAM = METER)
	PARAM =100;
    ELSE
	PARAM = 0;
	
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    IF (STARTUP) //IF CALLED FROM STARTUP_EVENT (OR DATA_EVENT:ONLINE).  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE//SEND SUBSCRIBE MESSAGE
    

}

DEFINE_CALL 'UN_SUBSCRIBE%'(CHAR OBJECT[6],INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //CALL THIS IF YOU WANT LONDON TO SEND PARAMETER UPDATES
{  //                  OBJECT = NODE+VD+OBJECT, SV = STATE VAR; PARAM = GAIN <3>,MUTE <1>,UNMUTE <0>,ROUTE <1>,UNROUTE <0>
    LOCAL_VAR INTEGER S_V;
    LOCAL_VAR INTEGER S_VLOW;
    LOCAL_VAR INTEGER S_VHIGH;
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR MY_RATE[4];
    LOCAL_VAR CHAR MY_STRING[13];

    
    EVENT = $8F; //EVENT FOR UN_SUBSCRIBE PERCENT

	
    S_V = GET_SV(DEVICE,INPUT,OUTPUT,PARAM)
    S_VLOW =  LO_BYTE(S_V);//LOW BYTE
    S_VHIGH = HI_BYTE(S_V); //HIGH BYTE
    PARAM = 0;
    MY_RATE = "$00,$00,$00,PARAM"; //SUBSCRIBE MESSAGE WITH 100ms ONLY FOR METERS
    MY_STRING = "EVENT,OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    
    IF (STARTUP) //IF CALLED FROM STARTUP_EVENT (OR DATA_EVENT:ONLINE).  THESE ARE VARIABLES YOU WANT TO PARSE FEEDBACK FOR.
    {
	T = T+1; //GLOBAL
	FB[T] = "OBJECT,S_VHIGH,S_VLOW,MY_RATE";
    }
    
    CALL 'CHECKSUM'(MY_STRING)//SEND SUBSCRIBE MESSAGE//SEND SUBSCRIBE MESSAGE
    
}

DEFINE_CALL 'CHECKSUM'(CHAR MY_STRING[13]) //CALCULATE CHECKSUM AND SEND STRING
{
LOCAL_VAR CHAR SEND[26];
LOCAL_VAR INTEGER I;
LOCAL_VAR CHAR CS;
    
    SEND = ""; CS = 0;
    
    FOR (I=1;I <= LENGTH_ARRAY(MY_STRING);I++)
    {
	CS = (CS BXOR MY_STRING[I]); //CHECKSUM;
	
	IF (IS_SPECIAL(MY_STRING[I])) //CHECK FOR SPECIAL CHARS
	    SEND = "SEND,$1B,(MY_STRING[I]+128)"; //CONCATENATE ESCAPE CHAR AND SPECIAL CHAR
	ELSE
	    SEND = "SEND,MY_STRING[I]";
        
    } 
    
    IF(IS_SPECIAL(CS))//CHECK TO MAKE SURE CALCULATED CHECKSUM IS NOT A SPECIAL CHAR
	SEND = "STX,SEND,$1B,(CS+128),ETX";
    ELSE
	SEND = "STX,SEND,CS,ETX";
	
    SEND_STRING dvSOUNDWEB, SEND;

	//IF(bDEBUG_FLAG==2) // if full debug ON, print everything...
	    //fnLOG_HEX(SEND,LENGTH_STRING(SEND),'--> SENT')
}

DEFINE_CALL 'SLONG_BYTES'(SLONG intGAIN, INTEGER GAIN_A[4]) //TAKES SLONG AND RETURNS INTEGER 32BIT VALUE IN 4 CHAR CHARACTERS
{
    LOCAL_VAR INTEGER INT;
    LOCAL_VAR INTEGER HINT;
    LOCAL_VAR LONG LINT;
    LOCAL_VAR INTEGER LHI_BYTE;
    LOCAL_VAR INTEGER LLO_BYTE;
    LOCAL_VAR INTEGER ULO_BYTE;
    LOCAL_VAR INTEGER UHI_BYTE;
    
    INT = TYPE_CAST(intGAIN); //GET LOW 16 BITS FROM SLONG
    LINT = TYPE_CAST(intGAIN); //GET UPPER 16 BITS FROM SLONG
    LHI_BYTE = HI_BYTE(INT); //LOWER HI_BYTE
    LLO_BYTE = LO_BYTE(INT); //LOWER LO_BYTE
    
    LINT = LINT >> 16;
    HINT = TYPE_CAST(LINT)
    UHI_BYTE = HI_BYTE(HINT); //UPPER HI_BYTE
    ULO_BYTE = LO_BYTE(HINT); //UPPER LO_BYTE
    
    GAIN_A[1] = UHI_BYTE; //GAIN_A IS THE RETURN ARRAY OF VALUES BY_REF
    GAIN_A[2] = ULO_BYTE;
    GAIN_A[3] = LHI_BYTE;
    GAIN_A[4] = LLO_BYTE;
}

DEFINE_CALL 'LONG_BYTES'(LONG intGAIN, INTEGER GAIN_A[4]) //TAKES LONG AND RETURNS INTEGER 32BIT VALUE IN 4 CHAR CHARACTERS
{
    LOCAL_VAR INTEGER INT;
    LOCAL_VAR INTEGER HINT;
    LOCAL_VAR LONG LINT;
    LOCAL_VAR INTEGER LHI_BYTE;
    LOCAL_VAR INTEGER LLO_BYTE;
    LOCAL_VAR INTEGER ULO_BYTE;
    LOCAL_VAR INTEGER UHI_BYTE;
    
    INT = TYPE_CAST(intGAIN); //GET LOW 16 BITS FROM SLONG
    LINT = TYPE_CAST(intGAIN); //GET UPPER 16 BITS FROM SLONG
    LHI_BYTE = HI_BYTE(INT); //LOWER HI_BYTE
    LLO_BYTE = LO_BYTE(INT); //LOWER LO_BYTE
    
    LINT = LINT >> 16;
    HINT = TYPE_CAST(LINT)
    UHI_BYTE = HI_BYTE(HINT); //UPPER HI_BYTE
    ULO_BYTE = LO_BYTE(HINT); //UPPER LO_BYTE
    
    GAIN_A[1] = UHI_BYTE; //GAIN_A IS THE RETURN ARRAY OF VALUES BY_REF
    GAIN_A[2] = ULO_BYTE;
    GAIN_A[3] = LHI_BYTE;
    GAIN_A[4] = LLO_BYTE;
}

DEFINE_CALL 'PROCESS_FEEDBACK'(CHAR RECEIVED_STRING[13])
{
    LOCAL_VAR CHAR EVENT;
    LOCAL_VAR CHAR NODE[2];
    LOCAL_VAR CHAR VD;
    LOCAL_VAR CHAR OBJECT[3];
    LOCAL_VAR CHAR SV[2];
    LOCAL_VAR CHAR MY_DATA[4];
    LOCAL_VAR CHAR RECEIVED[13]; //TEST
    LOCAL_VAR INTEGER I,J; //COUNTERS
    LOCAL_VAR CHAR CS; //CHECKSUM
    STACK_VAR INTEGER INDEX //DEBUG
    STACK_VAR CHAR HEX_DATA[100] // MAX SIZE


    EVENT = TYPE_CAST(LEFT_STRING(RECEIVED_STRING,1)); 
(*//DEBUG
    NODE = MID_STRING(RECEIVED_STRING,2,2);
    VD = MID_STRING(RECEIVED_STRING,4,1);
    OBJECT = MID_STRING(RECEIVED_STRING,5,3);
    SV = MID_STRING(RECEIVED_STRING,8,2);
*)
    RECEIVED_STRING = MID_STRING(RECEIVED_STRING,2,LENGTH_STRING(RECEIVED_STRING));  //CHOP OFF EVENT
    
    MY_DATA = RIGHT_STRING(RECEIVED_STRING,4);
    
    FOR (I = 1;I<=T;I++)//T is assigned in startup by the order and number of 'subscribes' called
    {
	IF(LEFT_STRING(RECEIVED_STRING,8)== LEFT_STRING(FB[I],8))//HiQnet address and SV of each object; elements 9-12 are the values of the SV
	{//MATCH - POPULATE VALUES IN FB[] FOR TRUE FEEDBACK
	    FB[I][9] = MY_DATA[1];
	    FB[I][10] = MY_DATA[2];
	    FB[I][11] = MY_DATA[3];
	    FB[I][12] = MY_DATA[4];
	    
	    IF (EVENT = $8D)//SET%
	    {
		iGAIN_FRACTION =  TYPE_CAST(MID_STRING(FB[I],11,1))*256 + TYPE_CAST(MID_STRING(FB[I],12,1)) //TAKE THE FRACTIONAL PART OF THE GAIN FADER TO DECIDE WHETHER TO ROUND UP OR DOWN FOR CLOSEST INTEGER AND SEND TO TP
		IF (iGAIN_FRACTION > 32767)//ROUND UP TO NEXT INTEGER
		    FB[I][10] = FB[I][10]+1 
	    }

	    I=T //DUMP OUT OF THE LOOP 
	}
    }

(* 
//DEBUG
//SEND_STRING 0, "'SV ', ITOHEX(TYPE_CAST(SV[1]<<8)+SV[2]), 'DATA ',ITOHEX(TYPE_CAST(MY_DATA[1]<<32)+TYPE_CAST(MY_DATA[2]<<16)+TYPE_CAST(MY_DATA[3]<<8)+MY_DATA[4])"
    HEX_DATA = "";
    FOR(INDEX=1;INDEX<=LENGTH_STRING(RECEIVED_STRING);INDEX++)
    {
        HEX_DATA="HEX_DATA,FORMAT(' $%02X',RECEIVED_STRING[INDEX])"
	//HEX_DATA="HEX_DATA,FORMAT(' #%d',RECEIVED_STRING[INDEX])" //decimal
    }
    	SEND_STRING 0,"'STRING ',HEX_DATA"
*)

}



DEFINE_FUNCTION INTEGER GET_SV(INTEGER DEVICE,INTEGER INPUT, INTEGER OUTPUT,INTEGER PARAM) //GET STATE VARIABLE
{
LOCAL_VAR INTEGER intSV;

SELECT 
 {
    ACTIVE ((DEVICE == AUTOMIXER)||(DEVICE == MIXER))://TO CONTROL INPUT CHANNEL PUT CHANNEL NUMBER IN 'INPUT' AND PUT 0 IN FOR OUTPUT;
    {		                                   // TO CONTROL OUTPUT PUT 0 IN INPUT AND L <1> OR R <3> IN OUTPUT
	IF(!(INPUT==0)&&(OUTPUT==0)) //OUTPUT FIELD = 0 SO MEANS ADJUST INPUT VALUES
	{
	    IF (PARAM == MUTE )
		intSV= 1+((INPUT-1)*100); 
	    ELSE IF (PARAM == GAIN)
		intSV = ((INPUT-1)*100); 
	    ELSE IF (PARAM == SOLO)
		intSV = (INPUT -1)*100 + 4;
	    ELSE IF (PARAM == OVERRIDE)
		intSV = (INPUT-1)*100+5;
	    ELSE IF (PARAM == AUTO)
		intSV = (INPUT-1)*100+7;
	    ELSE IF (PARAM == PAN)
		intSV = ((INPUT-1)*100+2);
	    ELSE IF (PARAM == OFF_GAIN)
		intSV = ((INPUT -1)*100+6);
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR NON-ZERO <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF((INPUT == 0) && (!(OUTPUT ==0))) //INPUT FIELD = 0 SO ADJUST OUTPUT VALUES (MASTER OUTPUTS)
	{
	    IF (PARAM == MUTE)
		intSV = 20000 + OUTPUT; //MUTE MASTER OUTPUT 20001 = LEFT; 20003 = RIGHT
	    ELSE IF(PARAM == GAIN)
		intSV = 20000 + OUTPUT - 1; //MUTE MASTER OUTPUT 20000 = LEFT; 20002 = RIGHT
	    ELSE IF(PARAM == AUX)
		intSV = (OUTPUT-1)*10 + 10002;
	    ELSE IF(PARAM == GROUP)
		intSV = (OUTPUT-1)*10+11001;
	    ELSE IF(PARAM == AUX_GAIN)
		intSV = ((OUTPUT-1)*10 + 10001);
	    ELSE IF(PARAM = GROUP_GAIN)
		intSV = ((OUTPUT-1)*10+11000);
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR NON-ZERO <OUTPUT> AND 0 <INPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF(PARAM == GROUP)
		intSV = (INPUT-1)*100 + (OUTPUT-1)+40;//ROUTE TO GROUP
	ELSE //ERROR MESSAGE TO CONSOLE
	    SEND_STRING 0,"'BSS_ERROR: Set Mixer - PARAM TYPE NOT FOUND FOR 0 <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	    
    }
    ACTIVE (DEVICE == ROOM_COMBINE)://TO CONTROL INPUT CHANNEL PUT CHANNEL NUMBER IN 'INPUT' AND PUT 0 IN FOR OUTPUT
    {
    	IF(!(INPUT==0)&&(OUTPUT==0)) //OUTPUT FIELD = 0 SO MEANS ADJUST INPUT VALUES
	{
	    IF (PARAM == SOURCE_MUTE)
		intSV = (INPUT-1)*50+256
	    ELSE IF (PARAM == BGM_MUTE)		
		intSV = (INPUT-1)*50+258
	    ELSE IF (PARAM == SOURCE_GAIN)		
		intSV = (INPUT-1)*50+255
	    ELSE IF (PARAM == BGM_GAIN)		
		intSV = (INPUT-1)*50+257
	    ELSE IF (PARAM == BGM_SELECT)//BACKGROUND MUSIC 		
		intSV = (INPUT-1)*50+259
	    ELSE IF (PARAM == PARTITION)
		intSV = (INPUT-1)
	    ELSE IF (PARAM == GROUP)
		intSV = (INPUT-1)*50 + 250
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Room Combine - PARAM TYPE NOT FOUND FOR NON-ZERO <INPUT> AND 0 <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF((INPUT == 0) && (!(OUTPUT == 0))) //INPUT FIELD = 0 SO ADJUST OUTPUT VALUES (MASTER OUTPUTS)
	{
	    IF (PARAM == MASTER_MUTE)
		intSV = (OUTPUT -1)*50+254
	    ELSE IF (PARAM == MASTER_GAIN)		
		intSV = (OUTPUT -1)*50+252
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Room Combine - PARAM TYPE NOT FOUND FOR 0 <INPUT> AND NON-ZERO <OUTPUT>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"    
	}
	ELSE //INPUT AND OUTPUT PARAMETERS ARE BOTH 0
	    SEND_STRING 0,"'BSS_ERROR: Message not supported for Room Combine. Either input or output MUST be = 0.  SEE HELP FILE.'"
	
    }
    ACTIVE ((DEVICE == ROUTER)||(DEVICE == MM)):
    {
	IF (PARAM == MUTE || PARAM == UNMUTE)
	    intSV = (INPUT-1)+((OUTPUT-1)*128); 
	ELSE IF (PARAM == GAIN)
	    intSV = (INPUT+16383)+((OUTPUT-1)*128);
	ELSE //ERROR MESSAGE TO CONSOLE
	    SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = ROUTER || MIXER.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
    }
    ACTIVE (DEVICE == N_GAIN):
    {
	IF (OUTPUT == 0) //N_GAIN DEVICE; ADJUST INPUT
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = (INPUT-1)+32;
	    ELSE IF (PARAM == GAIN)
		intSV = INPUT-1;
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = N_GAIN <OUTPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
	ELSE IF (INPUT == 0) //N_GAIN DEVICE; ADJUST MASTER OUTPUT
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = 97;
	    ELSE IF (PARAM == GAIN)
		intSV = 96;    
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = N_GAIN <INPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
    }
    ACTIVE (DEVICE == GAIN):
    {
	IF ((OUTPUT == 0) && (INPUT == 1)) //SINGLE GAIN DEVICE
	{
	    IF (PARAM == MUTE || PARAM == UNMUTE)
		intSV = 1;
	    ELSE IF (PARAM == GAIN)
		intSV = 0;
	    ELSE IF (PARAM == POLARITY_ON || PARAM == POLARITY_OFF)
		intSV = 2;
	    ELSE //ERROR MESSAGE TO CONSOLE
		SEND_STRING 0,"'BSS_ERROR: Set Val - PARAM TYPE NOT FOUND FOR DEVICE = GAIN <OUTPUT == 0>.  SEE HELP FILE FOR SUPPORTED MESSAGE TYPES'"
	}
    }
    ACTIVE (DEVICE == SOURCE_SELECTOR):
    {
	intSV = 0;
    }
    ACTIVE (DEVICE == SOURCE_MATRIX):
    {
	intSV = (INPUT - 1);
    }
    ACTIVE (DEVICE == INPUT_CARD):
    {
	IF(PARAM == GAIN)
	{
	    IF(INPUT == 1)
		intSV = 4;
	    ELSE IF(INPUT == 2)
		intSV = 10;
	    ELSE IF(INPUT == 3)
		intSV = 16;
	    ELSE IF(INPUT == 4)
		intSV = 22;
	}
	ELSE IF(PARAM == METER)
	    intSV = (INPUT-1)*6;
	ELSE IF(PARAM == PHANTOM)
	    INTSV = (INPUT-1)*6+5;
	ELSE IF(PARAM == REFERENCE)
	    intSV = (INPUT-1)*6+1;
	ELSE IF(PARAM == ATTACK)
	    intSV = (INPUT-1)*6+2;
	ELSE IF(PARAM == RELEASED)
	    intSV = (INPUT-1)*6+3;
    }
    ACTIVE (DEVICE == OUTPUT_CARD):
    {
	IF(PARAM == METER)
	    intSV = (INPUT-1)* 4;
	ELSE IF(PARAM == REFERENCE)
	    intSV = (INPUT-1)*4+1;
	ELSE IF(PARAM == ATTACK)
	    intSV = (INPUT-1)*4+2;
	ELSE IF(PARAM == RELEASED)
	    intSV = (INPUT-1)*4+3;
    }
    ACTIVE (DEVICE == METER):
    {
	IF(PARAM == METER)
	    intSV = 0;
    }
 }

RETURN intSV;
}
DEFINE_FUNCTION INTEGER IS_SPECIAL(CHAR SPECIAL_CHAR) //CHECK FOR SPECIAL CHARACTERS
{
LOCAL_VAR INTEGER intSPECIAL;


    IF ((SPECIAL_CHAR < 2) || (SPECIAL_CHAR > 27))
	intSPECIAL = 0;
    ELSE
    {
	SELECT
	{
	    ACTIVE (SPECIAL_CHAR = $02): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $03): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $06): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $15): {intSPECIAL = 1;}
	    ACTIVE (SPECIAL_CHAR = $1B): {intSPECIAL = 1;}
	}
    }
    
RETURN intSPECIAL;
}

DEFINE_FUNCTION INTEGER HI_BYTE(INTEGER IBYTE)//RETURN INTEGER BITS 9-16 IN SINGLE CHAR
{
    LOCAL_VAR INTEGER intHBYTE;
    
    intHBYTE = TYPE_CAST(IBYTE >> 8); //HIGH BYTE
    
    RETURN intHBYTE;
}

DEFINE_FUNCTION INTEGER LO_BYTE(INTEGER IBYTE) //RETURN INTEGER BITS 1-8 IN SINGLE CHAR
{
    LOCAL_VAR INTEGER intLBYTE;
    
    intLBYTE = TYPE_CAST(IBYTE << 8);
    intLBYTE = TYPE_CAST(intLBYTE >> 8); //LOW BYTE
    
    RETURN intLBYTE;
}

DEFINE_FUNCTION INTEGER scaleRange(LONG Num_In, LONG Min_In, LONG Max_In, LONG Min_Out, LONG Max_Out)
{
 
    LOCAL_VAR LONG Val_In
    LOCAL_VAR LONG Range_In
    LOCAL_VAR LONG Range_Out
    LOCAL_VAR LONG Whole_Num
    LOCAL_VAR FLOAT Num_Out

    
    Val_In = (Num_In/65536)         //Convert received number to percent range
    IF(Val_In == Min_In)            // Handle endpoints
        {Num_Out = Min_Out}
    ELSE IF(Val_In == Max_In)
        {Num_Out = Max_Out}
    ELSE                            // Otherwise scale...
    {
        Range_In = Max_In - Min_In      // Establish input range
        Range_Out = Max_Out - Min_Out   // Establish output range
        Val_In = Val_In - Min_In        // Remove input offset
        Num_Out = Val_In * Range_Out    // Multiply by output range
        Num_Out = Num_Out / Range_In    // Then divide by input range
        Num_Out = Num_Out + Min_Out     // Add in minimum output value
        Whole_Num = TYPE_CAST(Num_Out)  // Store the whole number only of the result
        IF (Num_Out >= 0 AND (((Num_Out - Whole_Num)* 100.0) >= 50.0)) 
	{
	    Num_Out++ // round up
	}    
        ELSE IF (Num_Out < 0 AND (((Num_Out - Whole_Num) * 100.0) <= -50.0))
	{ 
	    Num_Out-- // round down
	}    
    }
    Return TYPE_CAST(Num_Out)
}

DEFINE_FUNCTION LONG CHAR_LONGVAL(CHAR VALUE[4]) //TAKES A CHAR[4] ARRAY AND RETURNS A LONG
{
LOCAL_VAR INTEGER NUM1;   
LOCAL_VAR INTEGER NUM2; 
LOCAL_VAR INTEGER NUM3; 
LOCAL_VAR INTEGER NUM4; 
LOCAL_VAR LONG L_INT;

    NUM1 = VALUE[1];
    NUM2 = VALUE[2];
    NUM3 = VALUE[3];
    NUM4 = VALUE[4];

    L_INT = (NUM1*2^24)+(NUM2*65536)+(NUM3*256)+NUM4;
    
RETURN L_INT;
}
DEFINE_FUNCTION fnLOG_HEX(CHAR cDATA[], INTEGER LENGTH, CHAR cMESSAGE[]) // USED FOR HEX LOGGING TO TELNET
{
    STACK_VAR INTEGER INDEX
    STACK_VAR CHAR HEX_DATA[5000] // MAX SIZE  
    FOR(INDEX=1;INDEX<=LENGTH;INDEX++)
        HEX_DATA="HEX_DATA,FORMAT(' $%02X',cDATA[INDEX])"
    WHILE(LENGTH_STRING(HEX_DATA))
      {
        SEND_STRING 0,"cMESSAGE,GET_BUFFER_STRING(HEX_DATA,80)"
      }
    
}

DEFINE_FUNCTION fnLOG_DEC(CHAR cDATA[], INTEGER LENGTH, CHAR cMESSAGE[]) // USED FOR DECIMAL LOGGING
{
    STACK_VAR INTEGER INDEX
    STACK_VAR CHAR DEC_DATA[300]
    IF(LENGTH>100)
       LENGTH=100
    FOR(INDEX=1;INDEX<=LENGTH;INDEX++)
        DEC_DATA="DEC_DATA,FORMAT(' #%d',cDATA[INDEX])"
    SEND_STRING 0,"cMESSAGE,DEC_DATA"
    SET_LENGTH_STRING(DEC_DATA,0)
}
DEFINE_FUNCTION INTEGER fnParseRx(CHAR cBUFFER[])
{
    LOCAL_VAR INTEGER J; //RECEIVE LOOP VAR
    LOCAL_VAR INTEGER GOT_ESCAPE; 
    LOCAL_VAR CHAR R_SP; //RECEIVE SPECIAL CHARACTER
    LOCAL_VAR CHAR R_CS; //RECEIVE CHECKSUM
    LOCAL_VAR CHAR RECEIVE[25]; //TOTAL REAL RECEIVED MESSAGE AFTER CONVERTING SPECIAL CHARS
    LOCAL_VAR CHAR TEMP[25]; //PARSING TEMP VAR
    LOCAL_VAR CHAR T_CS; //TRANSMITTED CHECKSUM

	IF (LEFT_STRING(cBUFFER,1) = "ACK")//CHECK FOR ACK
	{
	    GET_BUFFER_CHAR(cBUFFER)//REMOVE FROM BUFFER
	    //IF(bDEBUG_FLAG==2) SEND_STRING 0,"' ACK'"
	    RETURN TRUE
	    //DO STUFF HERE FOR CORRECTLY TRANSMITTED STRING
	}
	ELSE IF (LEFT_STRING(cBUFFER,1) = "NAK")//CHECK FOR NAK
	{
	    GET_BUFFER_CHAR(cBUFFER)//REMOVE FROM BUFFER
	    IF(bDEBUG_FLAG==2) SEND_STRING 0,"' NAK'"
	    RETURN TRUE
	    //DO STUFF HERE FOR INCORRECT TRANSMITTED STRING
	}
	ELSE IF((cBUFFER[1] == "STX") && (FIND_STRING(cBUFFER,"ETX",1))) //FULL MESSAGE
	{
	    //SEND_STRING 0, "'FULL MESSAGE RECEIVED '"
	    nAttempts = 0
	    TEMP = REMOVE_STRING(cBUFFER,"ETX",1)//REMOVE STRING TO ETX
	    TEMP = MID_STRING(TEMP,2,(LENGTH_STRING(TEMP)-2));//CHOP OFF STX/ETX
	    RECEIVE = "";//INITIALIZE
	    R_CS = 0;//INITIALIZE
			
	    IF((MID_STRING(TEMP,(LENGTH_STRING(TEMP)-1),1)) = $1B) //CS IS SPECIAL CHAR
	    {
		T_CS = (TYPE_CAST(RIGHT_STRING(TEMP,1))-128)
		TEMP = MID_STRING(TEMP,1,(LENGTH_STRING(TEMP)-2))
	    }
	    ELSE
	    {
		T_CS = TYPE_CAST(RIGHT_STRING(TEMP,1))
		TEMP = MID_STRING(TEMP,1,(LENGTH_STRING(TEMP)-1))//THE (-1) IS TO REMOVE THE CHECKSUM FROM CALCULATIONS
	    }
	    FOR (J = 1;J <= LENGTH_STRING(TEMP);J++) //REPLACE SPECIAL CHARS AND GENERATE CHECKSUM
	    {                               
		IF (TEMP[J] = "$1B") //ESCAPE CHAR
		    GOT_ESCAPE = 1;
		ELSE
		{
		    IF (GOT_ESCAPE)
		    {
			R_SP = (TEMP[J]-128);
			R_CS = R_CS BXOR R_SP;
			RECEIVE = "RECEIVE,R_SP";
			GOT_ESCAPE = 0;
		    }
		    ELSE
		    {
			R_CS = R_CS BXOR TEMP[J];
			RECEIVE = "RECEIVE,TEMP[J]";
		    }
		}
	    }
	    IF (R_CS == T_CS)//MAKE SURE CHECKSUM = RECEIVED CHECKSUM AND MESSAGE IS RIGHT SIZE
		CALL 'PROCESS_FEEDBACK'(RECEIVE)
	    ELSE IF (bDEBUG_FLAG==2)
		SEND_STRING 0,"'BSS MESSAGE: BAD CHECKSUM OR MESSAGE LENGTH'"

	    RETURN TRUE
	}//FULL MESSAGE
	ELSE IF(cBUFFER[1]=="STX") // If we have received STX but the message is too short to be validated
	{
	    nAttempts++
	    IF(nAttempts>=5) 
	    {
		nAttempts = 0
		cBUFFER='' // clear the buffer after 5 failed attemps to receive a full message
		SEND_STRING 0, "'BSS MESSAGE: "ONLY STX RECEIVED: Partial Message" DUMPED '"
	    }
	    RETURN FALSE
	}
	ELSE // unrecognized reply...
	{
	    nAttempts = 0
	    cBUFFER = ''
	    RETURN FALSE
	    SEND_STRING 0, "'BSS MESSAGE: "UNRECOGNIZED REPLY" DUMPED '"
	}
}



(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

CREATE_BUFFER dvSOUNDWEB,cBUFFER
CLEAR_BUFFER cBUFFER
//bDEBUG_FLAG = 2

REPEAT_TIME[1] = 300; //300ms TO UPDATE FEEDBACK
TIMELINE_CREATE(TL1, REPEAT_TIME, 1, TIMELINE_ABSOLUTE,TIMELINE_REPEAT)//FEEDBACK TIMELINE; 
iRM1_GROUP = 99; //SET TO SOME BOGUS VALUE TO ENSURE FIRST PASS IN FEEDBACK IS UPDATED CORRECTLY
iRM2_GROUP = 99;
iRM3_GROUP = 99;
iRM4_GROUP = 99;

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT [dvSOUNDWEB]
{
    ONLINE:
    {	
	SEND_COMMAND dvSOUNDWEB, 'SET BAUD 115200,N,8,1 485 DISABLE'
	STARTUP = 1; //BEGIN LOGGING FEEDBACK VARIABLES:  THESE ARE THE ONLY VARIABLES 	
		    //THAT WILL BE COMPARED TO RECEIVED STRINGS FOR TRUE FEEDBACK
	T = 0; //initialization
      
	//SEE HELP FILE FOR COMPLETE DESCRIPTION OF FB[][] AND ON HOW THE SUBSCRIBE WORKS
	CALL 'SUBSCRIBE'(CHAP_AUTO,MIXER,1,0,MUTE) //FB[1][12] -- THIS IS THE VALUE YOU USE IN DEFINE_PROGRAM FOR BUTTON FEEDBACK
	CALL 'SUBSCRIBE'(CHAP_AUTO,MIXER,2,0,MUTE) //FB[2]
	CALL 'SUBSCRIBE'(CHAP_AUTO,MIXER,3,0,MUTE) //FB[3]
	CALL 'SUBSCRIBE'(CHAP_AUTO,MIXER,4,0,MUTE) //FB[4]
	CALL 'SUBSCRIBE'(CHAP_AUTO,MIXER,0,1,MUTE) //FB[5][12] //DISCRETES VALUES ARE ALWAYS HELD IN COLUMN 12  SEE DEFINE_PROGRAM
	
	CALL 'SUBSCRIBE'(CC_AUTO,AUTOMIXER,1,0,MUTE) //FB[6]
	CALL 'SUBSCRIBE'(CC_AUTO,AUTOMIXER,2,0,MUTE) //FB[7]
	CALL 'SUBSCRIBE'(CC_AUTO,AUTOMIXER,3,0,MUTE) //FB[8]
	CALL 'SUBSCRIBE'(CC_AUTO,AUTOMIXER,4,0,MUTE) //FB[9]
	CALL 'SUBSCRIBE'(CC_AUTO,AUTOMIXER,0,1,MUTE) //FB[10]
	
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,1,0,GAIN) //FB[11][10] //SUBSCRIBE %'S ARE ALWAYS HELD IN COLUMN 10
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,2,0,GAIN) //FB[12]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,3,0,GAIN) //FB[13]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,4,0,GAIN) //FB[14]
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,0,1,GAIN) //FB[15]
	
	CALL 'SUBSCRIBE'(VIDEO_SERVER,MM,1,1,UNMUTE) //FB[16][12]
	CALL 'SUBSCRIBE'(VIDEO_SERVER,MM,1,2,UNMUTE) //FB[17]
	CALL 'SUBSCRIBE'(VIDEO_SERVER,MM,1,3,UNMUTE) //FB[18]
	CALL 'SUBSCRIBE'(VIDEO_SERVER,MM,1,4,UNMUTE) //FB[19]
	CALL 'SUBSCRIBE'(VIDEO_SERVER,MM,1,5,UNMUTE) //FB[20][12]

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,SOURCE_MUTE)//FB[21][12]
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,SOURCE_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,BGM_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,1,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,2,MASTER_MUTE)//FB[30][12]
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,3,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,0,4,MASTER_MUTE)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,BGM_SELECT)
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,BGM_SELECT)//FB[36][12]

	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,1,0,SOURCE_GAIN)//FB[37][10] SUBSCRIBE %'S ALWAYS HELD IN COLUMN 10
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,2,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,3,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,4,0,SOURCE_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,1,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,2,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,3,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,4,0,BGM_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,1,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,2,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,3,MASTER_GAIN)
	CALL 'SUBSCRIBE%'(HALL_A,ROOM_COMBINE,0,4,MASTER_GAIN)//FB[48][10]

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,PARTITION)//FB[49][12]	//PARITION #1
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,PARTITION)//FB[50][12]	//PARITION #2
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,PARTITION)//FB[51][12]	//PARITION #3
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,PARTITION)//FB[52][12]	//PARITION #4

	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,1,0,GROUP)//FB[53][12] //ROOM #1 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,2,0,GROUP)//FB[54][12] //ROOM #2 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,3,0,GROUP)//FB[55][12] //ROOM #3 GROUP
	CALL 'SUBSCRIBE'(HALL_A,ROOM_COMBINE,4,0,GROUP)//FB[56][12] //ROOM #4 GROUP

	//SUBSCRIBING TO METERS CAUSES A LOT OF SERIAL TRAFFIC, USE WITH CARE
	//CALL 'SUBSCRIBE%'(IO_CARD1,INPUT_CARD,1,0,METER) //FB[21]


	STARTUP = 0; //END LOGGING FEEDBACK VARIABLES

    }
    STRING:
    {
 	    //IF(bDEBUG_FLAG==2) // if full debug ON, print everything...
		//fnLog_Hex(cBUFFER,LENGTH_STRING(cBUFFER),'received  <-- ')
            WHILE(fnParseRx(cBUFFER)) {/*DO NOTHING*/}
    }//STRING:
}//DATA_EVENT
LEVEL_EVENT[dvTP,1] //CONTROLLING GAIN USING AN ACTIVE LEVEL ON TP *Without* TRUE FEEDBACK
{
LOCAL_VAR FLOAT VOL;
LOCAL_VAR INTEGER PERCENT;
LOCAL_VAR INTEGER MODI;
 
    BARGRAPH = LEVEL.VALUE; //UPDATE GLOBAL VAR IN INCREMENT/DECREMENT BUTTON_EVENT 11,12
    //IF USING BARGRAPH ON AMX TP WITH RANGE 0-255
    //VOL = (BARGRAPH * .39); //SCALE 0-255 BARGRAPH TO 0-100% 
    //PERCENT = TYPE_CAST(VOL);
    //CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,1,0,Percent)

    //IF USING BARGRAPH ON AMX TP WITH RANGE 0-100
    CALL 'SET_GAIN%'(CHAP_AUTO,AUTOMIXER,1,0,LEVEL.VALUE)
    //SEND_COMMAND dvTP, "'TEXT1 -',ITOA(LEVEL.VALUE),'%'"; //SEND TEST TO TP

}
LEVEL_EVENT[dvTP,2]//GAIN USING ACTIVE LEVEL *With* FEEDBACK FROM LONDON
LEVEL_EVENT[dvTP,3]//ROOM_COMBINE RM1-4 SOURCE_GAIN 
LEVEL_EVENT[dvTP,4]
LEVEL_EVENT[dvTP,5]
LEVEL_EVENT[dvTP,6]//ROOM_COMBINE RM1-4 BGM_GAIN
LEVEL_EVENT[dvTP,7]
LEVEL_EVENT[dvTP,8]
LEVEL_EVENT[dvTP,9]
LEVEL_EVENT[dvTP,10]//ROOM_COMBINE RM1-4 MASTER_GAIN
LEVEL_EVENT[dvTP,11]
LEVEL_EVENT[dvTP,12]
LEVEL_EVENT[dvTP,13]
{

SELECT  //THIS SELECT STATEMENT IS TO PREVENT A FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS *With* TRUE FEEDBACK
{
    ACTIVE (LEVEL.INPUT.LEVEL = 2)://ROOM1 SOURCE_GAIN 	
    {
	IF(bUPDATE_OK[1])//BUTTON_EVENT ASSOCIATED WITH ACTIVE BARGRAPH
	    CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 3)://ROOM2 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[2])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,2,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 4)://ROOM3 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[3])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,3,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 5)://ROOM4 SOURCE_GAIN	
    {
	IF(bUPDATE_OK[4])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,4,0,SOURCE_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 6)://ROOM1 BGM_GAIN	
    {
	IF(bUPDATE_OK[5])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 7):///ROOM2 BGM_GAIN	
    {
	IF(bUPDATE_OK[6])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,2,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 8)://ROOM3 BGM_GAIN	
    {
	IF(bUPDATE_OK[7])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,3,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 9)://ROOM4 BGM_GAIN	
    {
	IF(bUPDATE_OK[8])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,4,0,BGM_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL = 10):	
    {
	IF(bUPDATE_OK[9])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,1,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =11):	
    {
	IF(bUPDATE_OK[10])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,2,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =12):	
    {
	IF(bUPDATE_OK[11])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,3,MASTER_GAIN,LEVEL.VALUE)
    }
    ACTIVE (LEVEL.INPUT.LEVEL =13):	
    {
	IF(bUPDATE_OK[12])
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,4,MASTER_GAIN,LEVEL.VALUE)
    }
}
(*
    IF(bUPDATE_OK)//BARGRAPH BUTTON FEEDBACK TO PREVENT FEEDBACK LOOP WHEN USING ACTIVE BARGRAPHS (SHORTER METHOD)
    {
	IF(LEVEL.INPUT.LEVEL <=5)//SOURCE_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,(LEVEL.INPUT.LEVEL-1),0,SOURCE_GAIN,LEVEL.VALUE)
	ELSE IF((LEVEL.INPUT.LEVEL >=6)&&(LEVEL.INPUT.LEVEL <=9))//BGM_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,(LEVEL.INPUT.LEVEL-5),0,BGM_GAIN,LEVEL.VALUE)
	ELSE IF(LEVEL.INPUT.LEVEL >=10)//MASTER_GAIN
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,(LEVEL.INPUT.LEVEL-9),MASTER_GAIN,LEVEL.VALUE)
    }
*)
}


(******************************************************************************************************************)
(******************************************************************************************************************)
(******************************************************************************************************************)
(***********)
(***********)
(***********)
(***********) 	//SEE INFOCOMM_06 FILE INLCLUDED IN MODULE DOWNLOAD FOR EXAMPLES ON CONTROLLING NEARLY EVERY 
(***********)   //SOUNDWEB LONDON PROCESSING OBJECT
(***********)
(******************************************************************************************************************)



(* SAMPLE FOR CONTROLLING INPUT CHANNELS 1-4 MUTE/UNMUTE ON A AUTOMIXER*)
//PUT A ZERO IN OUTPUT PARAMETER TO DENOTE YOU WANT TO CONTROL AN INPUT
BUTTON_EVENT [dvTP,1]
BUTTON_EVENT [dvTP,2]
BUTTON_EVENT [dvTP,3]
BUTTON_EVENT [dvTP,4]
{
PUSH:
    {

    IF(FB[PUSH_CHANNEL][12])//FB[1-4][12]: FB[] DIMENSION DETERMINED BY ORDER OF PLACEMENT IN DATA_EVENT:ONLINE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL,0,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,PUSH_CHANNEL,0,MUTE,1) 
	}
    }
}

(* SAMPLE FOR CONTROLLING MASTER FADER MUTE/UNMUTE ON A MIXER - DENOTED BY A ZERO IN INPUT AND 1 IN OUTPUT*)
BUTTON_EVENT [dvTP,5]
{
PUSH:
    {
    
    IF(FB[PUSH_CHANNEL][12])
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,0) 
	}
    ELSE
	{
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,1) 
	}
    }
    
}


(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER USE A *NON-ACTIVE* BARGRAPH *With* TRUE FEEBACK.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,13]
{
PUSH: //RAMP UP
    {
	IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	    MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	    CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,0,1,MasterOut_Vol)
	    FB[15][10] = TYPE_CAST(MASTEROUT_VOL) //UPDATE CENTRAL VARIABLE
	    CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,0,1,GAIN)//GET VALUE
	}
    }
HOLD[1,REPEAT]:
    {
	IF (MasterOut_Vol < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
	{
	    MasterOut_Vol = MasterOut_Vol + GAIN_STEP_PER;
	    CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,0,1,MasterOut_Vol)
	    FB[15][10] = TYPE_CAST( MASTEROUT_VOL) //UPDATE CENTRAL VARIABLE
	    CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,0,1,GAIN)//GET VALUE
	}
    }

}

(* SAMPLE OF CONTROLLING MASTER GAIN FADER ON A MIXER USE A *NON-ACTIVE* BARGRAPH *With* TRUE FEEBACK..  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN INPUT SPECIFIES YOU WANT TO CONTROL OUTPUT FADER
BUTTON_EVENT [dvTP,14]
{
PUSH://RAMP DOWN
    {
	IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
	{
	    MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	    CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,0,1,MasterOut_Vol)
	    FB[15][10] = TYPE_CAST( MASTEROUT_VOL) //UPDATE CENTRAL VARIABLE
	    CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,0,1,GAIN)//GET VALUE
	}
    }
HOLD[1,REPEAT]:
{
    IF (MasterOut_Vol > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
    {
	MasterOut_Vol = MasterOut_Vol - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,0,1,MasterOut_Vol)
	FB[15][10] = TYPE_CAST( MASTEROUT_VOL) //UPDATE CENTRAL VARIABLE
	CALL 'SUBSCRIBE%'(CHAP_AUTO,MIXER,0,1,GAIN)//GET VALUE
    }
}

}

(* SAMPLE OF CONTROLLING INPUT GAIN FADERS ON A MIXER USING AN *NON-ACTIVE* LEVEL ON TP *Without* TRUE FEEDBACK.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN OUTPUT SPECIFIES YOU WANT TO CONTROL INPUT FADER
BUTTON_EVENT [dvTP,11] 
{

PUSH: //RAMP UP
    {
    //BARGRAPH STORES VALUE OF ACTIVE BARGRAPH IN LEVEL_EVENT
    IF (BARGRAPH < (100-GAIN_STEP_PER))
	{
	BARGRAPH = BARGRAPH + GAIN_STEP_PER;
	SEND_LEVEL dvTP,1,BARGRAPH; //LEVEL_EVENT IS WHERE THE ACTUAL STRING IS SENT
	}
    }
HOLD[1,REPEAT]:
    {
    IF (BARGRAPH < (100-GAIN_STEP_PER))
	{
	BARGRAPH  = BARGRAPH  + GAIN_STEP_PER;
	SEND_LEVEL dvTP,1,BARGRAPH ;  
	}
    }
 
}

(* SAMPLE OF CONTROLLING INPUT GAIN FADERS ON A MIXER USING A *NON-ACTIVE LEVEL* ON TP *Without* TRUE FEEDBACK. *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN OUTPUT SPECIFIES YOU WANT TO CONTROL INPUT FADER
BUTTON_EVENT [dvTP,12]
{
PUSH: //RAMP DOWN
    {
    IF (BARGRAPH  > (GAIN_STEP_PER))
	{
	BARGRAPH  = BARGRAPH - GAIN_STEP_PER;
	SEND_LEVEL dvTP,1,BARGRAPH ;
	}
    }
HOLD[1,REPEAT]:
    {
    IF (BARGRAPH  > (GAIN_STEP_PER))
	{
	BARGRAPH  = BARGRAPH  - GAIN_STEP_PER;
	SEND_LEVEL dvTP,1,BARGRAPH;
	}
    }

}


(* SAMPLE OF CONTROLLING ALL THREE INPUT GAIN FADERS ON A MIXER.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN OUTPUT SPECIFIES YOU WANT TO CONTROL INPUT FADER
BUTTON_EVENT [dvTP,15]
{
PUSH: //RAMP UP
    {
IF (RAMP_GAIN_PER < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
    {
	RAMP_GAIN_PER = RAMP_GAIN_PER + GAIN_STEP_PER;
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,2,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,3,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,4,0,RAMP_GAIN_PER)
    }
}
HOLD[1,REPEAT]:
{
    IF (RAMP_GAIN_PER < (MAX_RAMPGAIN_PER-GAIN_STEP_PER))
    {
	RAMP_GAIN_PER = RAMP_GAIN_PER + GAIN_STEP_PER;
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,2,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,3,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,4,0,RAMP_GAIN_PER)
    }
}

}

(* SAMPLE OF CONTROLLING ALL FOUR INPUT GAIN FADERS ON A MIXER.  HOLD EVENT <TIME> SPECIFIES HOW FAST YOU WANT TO RAMP *)
(* IF YOU ALWAYS WANT TO CONTROL ALL FOUR THEN IT IS BETTER TO LINK THE CONTROLS IN LONDON ARCHITECT. THEN YOU ONLY HAVE TO SEND ONE STRING *)
// IF USING SET_GAIN%, 1% = <1/3dB>
//A ZERO IN OUTPUT SPECIFIES YOU WANT TO CONTROL INPUT FADER
BUTTON_EVENT [dvTP,16]
{
PUSH: //RAMP DOWN
{
    IF (RAMP_GAIN_PER > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
    {
	RAMP_GAIN_PER = RAMP_GAIN_PER - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,2,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,3,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,4,0,RAMP_GAIN_PER)
    }
}
HOLD[1,REPEAT]:
{
    IF (RAMP_GAIN_PER > (MIN_RAMPGAIN_PER+GAIN_STEP_PER))
    {
	RAMP_GAIN_PER = RAMP_GAIN_PER - GAIN_STEP_PER;
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,2,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,3,0,RAMP_GAIN_PER)
	CALL 'SET_GAIN%'(CHAP_AUTO,MIXER,4,0,RAMP_GAIN_PER)
    }
}
}

(* SAMPLE FOR ROUTING GROUPS ON A MIXER *)
BUTTON_EVENT [dvTP,17]
{
PUSH:
    {
        CALL 'SET_MIXER'(CHAP_AUTO,1,1,GROUP,1) //SEND INPUT 1 TO GROUP 1
        CALL 'SET_MIXER'(CHAP_AUTO,4,2,GROUP,1) //SEND INPUT 4 TO GROUP 2
	CALL 'SET_MIXER'(CHAP_AUTO,3,2,GROUP,0)  //UNGROUP INPUT 3 FROM GROUP 2
    }
}

(*SAMPLE OF SETTING CROSSPOINT GAINS ON A MATRIX MIXER USING SET_GAIN% *)
BUTTON_EVENT [dvTP,19]
{
PUSH:
    {
        CALL 'SET_GAIN%'(VIDEO_SERVER,MM,1,1,100)//SET GAIN ON CROSSPOINT INPUT 1 OUTPUT 1 AT MAX <10dB>
	CALL 'SET_GAIN%'(VIDEO_SERVER,MM,1,10,73)//SET GAIN ON CROSSPOINT INPUT 1 OUTPUT 10 <0dB>
	CALL 'SET_GAIN%'(VIDEO_SERVER,MM,15,12,0)//SET GAIN ON CROSSPOINT INPUT 15 OUTPUT 12 TO MIN <-70dB>
    }

}
(*SAMPLE OF SETTING CROSSPOINT GAINS ON A MATRIX MIXER USING SET_GAIN*)
BUTTON_EVENT [dvTP,18]
{
PUSH:
    {
        CALL 'SET_GAIN'(VIDEO_SERVER,MM,1,1,100000)//SET GAIN ON CROSSPOINT INPUT 1 OUTPUT 1 AT MAX <10dB>
	CALL 'SET_GAIN'(VIDEO_SERVER,MM,1,10,0)//SET GAIN ON CROSSPOINT INPUT 1 OUTPUT 10 <0dB>
    }
}

(*SAMPLE OF SETTING CROSSPOINTS ON A ROUTER, MATRIX MIXER  *)
BUTTON_EVENT [dvTP,20]
{
    PUSH:
    {
	CALL 'SET_VAL'(VIDEO_SERVER,MM,1,10,ROUTE,1)//ROUTE CROSSPOINT INPUT 1 TO OUTPUT 10
	CALL 'SET_VAL'(VIDEO_SERVER,MM,15,12,ROUTE,0)//UNROUTE CROSSPOINT INPUT 15 TO OUTPUT 12 
    }

}

(*  EXAMPLE FOR ROUTING/UNROUTING MATRIX MIXER CROSSPOINTS *)
BUTTON_EVENT [dvTP,21]
BUTTON_EVENT [dvTP,22]
BUTTON_EVENT [dvTP,23]
BUTTON_EVENT [dvTP,24]
BUTTON_EVENT [dvTP,25]
{
    PUSH:
    {
	MATRIX_INPUT = (PUSH_CHANNEL-20); //SET INPUT CHANNEL
    }

}
BUTTON_EVENT [dvTP,31]
BUTTON_EVENT [dvTP,32]
BUTTON_EVENT [dvTP,33]
BUTTON_EVENT [dvTP,34]
BUTTON_EVENT [dvTP,35]
{
    PUSH:
    {
	MATRIX_OUTPUT = (PUSH_CHANNEL-30); //SET OUTPUT CHANNEL
    }
}
BUTTON_EVENT [dvTP,26] //MUTE CROSSPOINTS ON MATRIX MIXER. CHANNELS HELD BY VARIABLES
{
    PUSH:
    {
	CALL 'SET_VAL'(VIDEO_SERVER,MM,MATRIX_INPUT,MATRIX_OUTPUT,MUTE,1)
	
    }

}
BUTTON_EVENT [dvTP,36] //UNMUTE CROSSPOINTS ON MATRIX MIXER. CHANNELS HELD BY VARIABLES
{
    PUSH:
    {
	CALL 'SET_VAL'(VIDEO_SERVER,MM,MATRIX_INPUT,MATRIX_OUTPUT,MUTE,0)
    }
}
	

BUTTON_EVENT [dvTP,50]
{
    PUSH:
    {
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,SOLO,1)//OUPUT FIELD MUST BE ZERO TO CONTROL AN INPUT 
	CALL 'SET_MIXER'(CHAP_AUTO,3,1,GROUP,1)
	CALL 'SET_MIXER'(CHAP_AUTO,1,2,GROUP,0)
    }

}
(* AUTOMIXER *)
BUTTON_EVENT [dvTP,51]
{
    PUSH: 
    {
	CALL 'SET_MIXER'(CHAP_AUTO,0,1,MUTE,1) 
	CALL 'SET_MIXER'(CHAP_AUTO,4,0,SOLO,0)
    }
}

(* RECALLING PRESETS *)
BUTTON_EVENT [dvTP,52]
{
PUSH: 
    {
    CALL 'SET_PRESET'(PARAMETER_PRESET,1)
    CALL 'SET_PRESET'(DEVICE_PRESET,2)
    }
}

(* USING GAIN AND N-GAIN DEVICES *)
BUTTON_EVENT [dvTP,60]
{
PUSH: 
    {
    CALL 'SET_GAIN%'(IO_CARD1,GAIN,1,0,73) //SET THE GAIN DEVICE FADER TO 0dB
    CALL 'SET_GAIN%'(IO_CARD1,GAIN,1,0,50) //SET THE GAIN DEVICE FADER TO 50dB
    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,1,0,MUTE,1)// MUTE THE N-GAIN DEVICE FADER 1
    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,3,0,80)// SET THE N-GAIN DEVICE FADER 3 TO 80%
    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,0,1,80)// SET THE N-GAIN DEVICE MASTER FADER  TO 80%; A ZERO IN INPUT MEANS ADJUST OUTPUT ONLY
    }
}


BUTTON_EVENT [dvTP,54]
{
PUSH: 
    {

    CALL 'SET_GAIN%'(BLU_ROOMGAIN,GAIN,1,0,73) //SET THE GAIN DEVICE FADER TO 0dB
    CALL 'SET_VAL'(BLU_ROOMGAIN,GAIN,1,0,MUTE,1) //MUTE THE GAIN DEVICE 
    CALL 'SET_VAL'(RED_ROOMGAIN,N_GAIN,1,0,MUTE,1)// MUTE THE N-GAIN DEVICE FADER 1
    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,3,0,80)// SET THE N-GAIN DEVICE FADER 3 TO 80%
    CALL 'SET_GAIN%'(RED_ROOMGAIN,N_GAIN,0,1,80)// SET THE N-GAIN DEVICE MASTER FADER  TO 80%; A ZERO IN INPUT MEANS ADJUST OUTPUT ONLY
    }
}

BUTTON_EVENT [dvTP,55]
{
PUSH:
    {
    CALL 'SET_MIXER'(CHAP_AUTO,0,1,AUX,1)//MUTE AUX A OUTPUT ;INPUT FIELD MUST BE ZERO TO CONTROL AN OUTPUT FUNCTION 
    CALL 'SET_MIXER'(CHAP_AUTO,0,B,AUX,1)//MUTE AUX B OUTPUT
    CALL 'SET_MIXER'(CHAP_AUTO,0,C,AUX,0)//UNMUTE AUX C OUPUT
    }

}

BUTTON_EVENT [dvTP,56]
{
PUSH:
    {
    CALL 'SET_MIXER'(CHAP_AUTO,0,1,GROUP,1)//MUTE OUTPUT MASTER GROUP 1;INPUT FIELD MUST BE ZERO TO CONTROL AN OUTPUT FUNCTION 
    CALL 'SET_MIXER'(CHAP_AUTO,0,2,GROUP,0)//UNMUTE GROUP B MASTER OUTPUT
    }

}
BUTTON_EVENT [dvTP,57]
{
PUSH:
    {
    CALL 'SET_MIXER'(CHAP_AUTO,1,0,OVERRIDE,1)//ON CHANNEL 1 OVERRIDE;OUPUT FIELD MUST BE ZERO TO CONTROL AN INPUT FUNCTION 
    CALL 'SET_MIXER'(CHAP_AUTO,2,0,OVERRIDE,0)//OFF CHANNEL 2 OVERRIDE
    CALL 'SET_MIXER'(CHAP_AUTO,3,0,OVERRIDE,1)//ON CHANNEL 3 OVERRIDE
    CALL 'SET_MIXER'(CHAP_AUTO,3,0,AUTO,1)//OFF CHANNEL 3 AUTO
    CALL 'SET_MIXER'(CHAP_AUTO,1,0,OVERRIDE,0)//OFF CHANNEL 1 OVERRIDE
    
    }
}

(***********************************************************************************************************)
(********************************************   ROOM COMBINE    ********************************************)
(***********************************************************************************************************)
//ALL ROOM COMBINE CODE IS TRUE FEEDBACK
BUTTON_EVENT [dvTP,100]//ROOM_COMBINE SOURCE MUTE ROOM 1-4
BUTTON_EVENT [dvTP,101]
BUTTON_EVENT [dvTP,102]
BUTTON_EVENT [dvTP,103]
{
PUSH:
    {

	IF(FB[PUSH_CHANNEL-79][12])//FB[21], FB[22], FB[23], FB[24] IN DATA_EVENT:ONLINE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-99,0,SOURCE_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-99,0,SOURCE_MUTE,1)//MUTE

    }
}
BUTTON_EVENT [dvTP,104]//ROOM_COMBINE BGM MUTE ROOM 1-4
BUTTON_EVENT [dvTP,105]
BUTTON_EVENT [dvTP,106]
BUTTON_EVENT [dvTP,107]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-79][12])//FB[25-28]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-103,0,BGM_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-103,0,BGM_MUTE,1)//MUTE
    }
}

BUTTON_EVENT [dvTP,108]//ROOM_COMBINE MASTER_MUTE ROOM 1-4
BUTTON_EVENT [dvTP,109]
BUTTON_EVENT [dvTP,110]
BUTTON_EVENT [dvTP,111]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-79][12])//FB[29-32]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,PUSH_CHANNEL-107,MASTER_MUTE,0)//UNMUTE
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,0,PUSH_CHANNEL-107,MASTER_MUTE,1)//MUTE
    }
}

BUTTON_EVENT [dvTP,112]//ROOM_COMBINE BGM_SELECT INPUT 1
BUTTON_EVENT [dvTP,113]
BUTTON_EVENT [dvTP,114]
BUTTON_EVENT [dvTP,115]
{
PUSH:
    {
	//CALL 'SET_ROOMCOMBINE'(HALL_A,1,0,BGM_SELECT,0)//ROOM 1 NO SOURCE
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-111,0,BGM_SELECT,1)//ROOM 1 INPUT 1
    }
}
BUTTON_EVENT [dvTP,116]//ROOM_COMBINE BGM_SELECT INPUT 2
BUTTON_EVENT [dvTP,117]
BUTTON_EVENT [dvTP,118]
BUTTON_EVENT [dvTP,119]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-115,0,BGM_SELECT,2)//ROOM 1 INPUT 2
    }
}
BUTTON_EVENT [dvTP,120]//ROOM_COMBINE BGM_SELECT INPUT 3
BUTTON_EVENT [dvTP,121]
BUTTON_EVENT [dvTP,122]
BUTTON_EVENT [dvTP,123]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-119,0,BGM_SELECT,3)//ROOM 1 INPUT 3
    }
}
BUTTON_EVENT [dvTP,124]//ROOM_COMBINE BGM_SELECT INPUT 4
BUTTON_EVENT [dvTP,125]
BUTTON_EVENT [dvTP,126]
BUTTON_EVENT [dvTP,127]
{
PUSH:
    {
	CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-123,0,BGM_SELECT,4)//ROOM 1 INPUT 4
    }
}

BUTTON_EVENT [dvTP,132]//ACTIVE BARGRAPH CHANNEL CODE TO PREVENT FEEBACK LOOP *With* TRUE FEEDBACK
{
    PUSH:	bUPDATE_OK[1] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[1] = FALSE}//TO LET BUFFER UNSPOOL TO PREVENT BARGRAPH JUMP
}
BUTTON_EVENT [dvTP,133]
{
    PUSH:	bUPDATE_OK[2] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[2] = FALSE}
}
BUTTON_EVENT [dvTP,134]
{
    PUSH:	bUPDATE_OK[3] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[3] = FALSE}
}
BUTTON_EVENT [dvTP,135]
{
    PUSH:	bUPDATE_OK[4] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[4] = FALSE}
}
BUTTON_EVENT [dvTP,136]
{
    PUSH:	bUPDATE_OK[5] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[5] = FALSE}
}
BUTTON_EVENT [dvTP,137]
{
    PUSH:	bUPDATE_OK[6] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[6] = FALSE}
}
BUTTON_EVENT [dvTP,138]
{
    PUSH:	bUPDATE_OK[7] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[7] = FALSE}
}
BUTTON_EVENT [dvTP,139]
{
    PUSH:	bUPDATE_OK[8] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[8] = FALSE}
}
BUTTON_EVENT [dvTP,140]
{
    PUSH:	bUPDATE_OK[9] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[9] = FALSE}
}
BUTTON_EVENT [dvTP,141]
{
    PUSH:	bUPDATE_OK[10] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[10] = FALSE}
}
BUTTON_EVENT [dvTP,142]
{
    PUSH:	bUPDATE_OK[11] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[11] = FALSE}
}
BUTTON_EVENT [dvTP,143]
{
    PUSH:	bUPDATE_OK[12] = TRUE
    RELEASE:  WAIT 5 {bUPDATE_OK[12] = FALSE}
}

BUTTON_EVENT [dvTP,150]//PARTITION 1-4
BUTTON_EVENT [dvTP,151]
BUTTON_EVENT [dvTP,152]
BUTTON_EVENT [dvTP,153]
{
PUSH:
    {
	IF(FB[PUSH_CHANNEL-101][12])//FB[49-52][12]
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-149,0,PARTITION,0)//CLOSE PARTITION
	ELSE
	    CALL 'SET_ROOMCOMBINE'(HALL_A,PUSH_CHANNEL-149,0,PARTITION,1)//OPEN PARTITION
    }
}




TIMELINE_EVENT[TL1]//FEEDBACK TIMELINE
{
    //FOR ALL DISCRETE SV'S (MUTES, ROUTES, ETC) THE 12TH BYTE <FB[][12]> HOLDS THE ZERO OR ONE (MUTE OR UNMUTE) STATE OF STATE VARIABLE
    //FOR ALL GAIN% SV'S THE 10TH BYTE <FB[][10]> WILL HOLD THE VALUE OF THE FADER IN PERCENT <0-100>. THE 11TH AND 12TH ELEMENT IS THE FRACTIONAL (DECIMAL) VALUE (IE 67.003%) USED ONLY FOR ROUNDING TO THE NEAREST INTEGER FOR THIS SAMPLE PROGAM. THE PROGRAMMER CAN MODIFY TO USE THIS EXTRA RESOLUTION IF DESIRED
    //SEE HELP FILE FOR COMPLETE FB[][] STRUCTURE
    [dvTP,1] = FB[1][12];//REAL FEEDBACK - THE 12TH BYTE HOLDS THE ZERO OR ONE (MUTE OR UNMUTE) STATE OF STATE VARIABLE
    [dvTP,2] = FB[2][12];//REAL
    [dvTP,3] = FB[3][12];//REAL
    [dvTP,4] = FB[4][12];//REAL
    [dvTP,5] = FB[5][12];
    [dvTP,6] = FB[6][12];
    [dvTP,7] = FB[7][12];
    [dvTP,8] = FB[8][12];
    [dvTP,9] = FB[9][12];
    
    [dvTP,100] = FB[21][12];//ROOM_COMBINE SOURCE_MUTE
    [dvTP,101] = FB[22][12];
    [dvTP,102] = FB[23][12];
    [dvTP,103] = FB[24][12];
    [dvTP,104] = FB[25][12];//ROOM_COMBINE BGM_MUTE
    [dvTP,105] = FB[26][12];
    [dvTP,106] = FB[27][12];
    [dvTP,107] = FB[28][12];
    [dvTP,108] = FB[29][12];//ROOM_COMBINE MASTER_MUTE
    [dvTP,109] = FB[30][12];
    [dvTP,110] = FB[31][12];
    [dvTP,111] = FB[32][12];
    //[dvTP,112] = FB[33][12] = 0;//ROOM_COMBINE ROOM1 BGM_SELECT NO SOURCE
    [dvTP,112] = FB[33][12] = 1;//ROOM_COMBINE ROOM1 BGM_SELECT SOURCE
    [dvTP,116] = FB[33][12] = 2;
    [dvTP,120] = FB[33][12] = 3;
    [dvTP,124] = FB[33][12] = 4;
    [dvTP,113] = FB[34][12] = 1;//ROOM_COMBINE ROOM2 BGM_SELECT SOURCE 
    [dvTP,117] = FB[34][12] = 2;
    [dvTP,121] = FB[34][12] = 3;
    [dvTP,125] = FB[34][12] = 4;
    [dvTP,114] = FB[35][12] = 1;//ROOM_COMBINE ROOM3 BGM_SELECT SOURCE 
    [dvTP,118] = FB[35][12] = 2;
    [dvTP,122] = FB[35][12] = 3;
    [dvTP,126] = FB[35][12] = 4;
    [dvTP,115] = FB[36][12] = 1;//ROOM_COMBINE ROOM4 BGM_SELECT SOURCE 
    [dvTP,119] = FB[36][12] = 2;
    [dvTP,123] = FB[36][12] = 3;
    [dvTP,127] = FB[36][12] = 4;
    [dvTP,150] = FB[49][12];//ROOM_COMBINE PARTITION 1
    [dvTP,151] = FB[50][12];//ROOM_COMBINE PARTITION 2
    [dvTP,152] = FB[51][12];//ROOM_COMBINE PARTITION 3
    [dvTP,153] = FB[52][12];//ROOM_COMBINE PARTITION 4
    
    
(********************************   DYNAMIC TOUCH PANEL COMMANDS FOR ROOM COMBINE GROUP COLORS   *************)
    IF (iRM1_GROUP != FB[53][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[53][12] = 0)//ROOM_COMBINE ROOM1 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-15,0,1'" //CHANGE ROOM1 BUTTON TO STATE 1
	ELSE IF (FB[53][12] = 1)//ROOM_COMBINE ROOM1 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-15,0,2'" //CHANGE ROOM1 BUTTON TO STATE 2
	ELSE IF (FB[53][12] = 2)//ROOM_COMBINE ROOM1 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-15,0,3'" //CHANGE ROOM1 BUTTON TO STATE 3
	iRm1_Group = FB[53][12];
    }
    
    IF (iRM2_GROUP != FB[54][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[54][12] = 0)//ROOM_COMBINE ROOM2 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-16,0,1'" //CHANGE ROOM2 BUTTON TO STATE 1
	ELSE IF (FB[54][12] = 1)//ROOM_COMBINE ROOM2 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-16,0,2'" //CHANGE ROOM2 BUTTON TO STATE 2
	ELSE IF (FB[54][12] = 2)//ROOM_COMBINE ROOM2 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-16,0,3'" //CHANGE ROOM2 BUTTON TO STATE 3
	iRM2_GROUP = FB[54][12];
    }
    
    IF (iRM3_GROUP != FB[55][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[55][12] = 0)//ROOM_COMBINE ROOM3 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-17,0,1'" //CHANGE ROOM3 BUTTON TO STATE 1
	ELSE IF (FB[55][12] = 1)//ROOM_COMBINE ROOM3 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-17,0,2'" //CHANGE ROOM3 BUTTON TO STATE 2
	ELSE IF (FB[55][12] = 2)//ROOM_COMBINE ROOM3 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-17,0,3'" //CHANGE ROOM3 BUTTON TO STATE 3
	iRM3_GROUP = FB[55][12];
    }

    IF (iRM4_GROUP != FB[56][12])//JUST TO MAKE SURE THE COMMAND IS ONLY SENT WHEN A CHANGE IS DETECTED TO PREVENT UNCESSARY DEVICE_MANAGER LOADING
    {
	IF (FB[56][12] = 0)//ROOM_COMBINE ROOM4 GROUP = 0
	    SEND_COMMAND DVTP, "'^ANI-18,0,1'" //CHANGE ROOM4 BUTTON TO STATE 1
	ELSE IF (FB[56][12] = 1)//ROOM_COMBINE ROOM4 GROUP = 1
	    SEND_COMMAND DVTP, "'^ANI-18,0,2'" //CHANGE ROOM4 BUTTON TO STATE 2
	ELSE IF (FB[56][12] = 2)//ROOM_COMBINE ROOM4 GROUP = 2
	    SEND_COMMAND DVTP, "'^ANI-18,0,3'" //CHANGE ROOM4 BUTTON TO STATE 3
	iRM4_GROUP = FB[56][12]
    }
(************************************************************************************************************)
    
    
    (* TO UPDATE VOLUME BAR GRAPHS WHEN USING A NON ACTIVE BAR GRAPH AND *With* TRUE FEEDBACK*) //SEE BUTTON_EVENT 13,14
    (*IF USING SUBSCRIBE PERCENT!!! AND TP HAS LEVEL PROPERTY SET FROM 0-100*)
    MASTEROUT_VOL =TYPE_CAST(MID_STRING(FB[15],10,1)); //FB[15] IS THE POSITION IN STARTUP THAT I SUBSCRIBED TO. HAS RANGE <0-100>
    SEND_LEVEL dvTP, 20, MASTEROUT_VOL;

    
    
(***************************************************************)
    (* TO UPDATE VOLUME BAR GRAPHS WHEN USING ACTIVE BAR GRAPH*)(*SEE LEVEL_EVENT AS WELL*)
    //BUTTON_EVENT 132-143 IS WHERE THESE VARS ARE SET.  EACH VAR IS THE PUSH EVENT ASSOCIATED WITH AN ACTIVE BARGRAPH
    //THE 10TH ELEMENT (FB[][10]) IS THE PERCENT VALUE (0-100) THAT IS SENT TO THE BARGRAPH. THE 11TH AND 12TH ELEMENT IS THE FRACTIONAL (DECIMAL) VALUE (IE 67.003%) USED ONLY FOR ROUNDING TO THE NEAREST INTEGER FOR THIS SAMPLE PROGAM. THE PROGRAMMER CAN MODIFY TO USE THIS EXTRA RESOLUTION IF DESIRED

    IF (!bUPDATE_OK[1])//UPDATE ACTIVE BARGRAPH FEEDBACK FROM NON AMX DEVICE (ie LONDON ARCHITECT, 10K POT, ETC)
	SEND_LEVEL dvTP,2,TYPE_CAST(MID_STRING(FB[37],10,1))//SOURCE_GAIN ROOM1
    IF (!bUPDATE_OK[2])
	SEND_LEVEL dvTP,3,TYPE_CAST(MID_STRING(FB[38],10,1))//SOURCE_GAIN ROOM2
    IF (!bUPDATE_OK[3])
	SEND_LEVEL dvTP,4,TYPE_CAST(MID_STRING(FB[39],10,1))//SOURCE_GAIN ROOM3
    IF (!bUPDATE_OK[4])
	SEND_LEVEL dvTP,5,TYPE_CAST(MID_STRING(FB[40],10,1))//SOURCE_GAIN ROOM4
    IF (!bUPDATE_OK[5])
	SEND_LEVEL dvTP,6,TYPE_CAST(MID_STRING(FB[41],10,1))//BGM_GAIN
    IF (!bUPDATE_OK[6])
	SEND_LEVEL dvTP,7,TYPE_CAST(MID_STRING(FB[42],10,1))
    IF (!bUPDATE_OK[7])
	SEND_LEVEL dvTP,8,TYPE_CAST(MID_STRING(FB[43],10,1))
    IF (!bUPDATE_OK[8])
	SEND_LEVEL dvTP,9,TYPE_CAST(MID_STRING(FB[44],10,1))
    IF (!bUPDATE_OK[9])
	SEND_LEVEL dvTP,10,TYPE_CAST(MID_STRING(FB[45],10,1))//MASTER_GAIN
    IF (!bUPDATE_OK[10])
	SEND_LEVEL dvTP,11,TYPE_CAST(MID_STRING(FB[46],10,1))
    IF (!bUPDATE_OK[11])
	SEND_LEVEL dvTP,12,TYPE_CAST(MID_STRING(FB[47],10,1))
    IF (!bUPDATE_OK[12])
	SEND_LEVEL dvTP,13,TYPE_CAST(MID_STRING(FB[48],10,1))
(*******************************************************************)
}


(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

//ALL FEEDBACK HANDLED IN TIMELINE[TL1] EVENT FOR BETTER PERFORMANCE (AS REQUESTED BY AMX PERSONNEL)
//THE PROGRAMMER CAN ELIMINATE THE TIMELINE AND PLACE ALL FEEDBACK HERE IF THEY ARE MORE COMFORTABLE WITH THAT METHOD AS SHOWN IN THE INFOCOMM 06 FILE

